#!/usr/bin/perl
##############################################################################
# Cliff's Links Trader Version 1.52                                          # 
# Copyright 1998 Shaven Ferret Productions                                   #
# Created 7/02/98    Last Modified 11/30/98                                  #  
# Available at http://www.shavenferret.com/scripts                           #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1998 Shaven Ferret Productions All Rights Reserved.              #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header or any part that gives me credit for writing this.  If  #
# you really need to change these things, go to                              #
# http://www.shavenferret.com/scripts/registers.shtml . By using this script #
# you agree to indemnify me from any liability that might arise from its use.#
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################

# Enter the path to the data file.  if you put the data file in the same
# directory as the script, you can leave this as it is.
$datafile = "linkt.txt";

# Enter the location of your mail program.  
$mailprogram = "/usr/lib/sendmail";

# Enter the full URL of this script once it is uploaded
$scripturl = "http://www.yourdomain.com/cgi-bin/linkt.cgi";

# If you don't have libwww-perl on your system, delete the next line
use LWP::Simple; $lwp = 1;

##############################################################################
# Congratulations!  You've finished defining the variables.  If you want to, #
# you can continue screwing with the script, but it isn't necessary.         #
##############################################################################

$| = -1;
if ($ENV{"REQUEST_METHOD"} eq 'GET') {
        $buffer = $ENV{'QUERY_STRING'};
}
else {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}

# Put the data into variables

@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $FORM{$name} = $value;
}
unless ($FORM{'action'} eq "go" || $FORM{'action'} eq "random") { print "Content-type: text/html\n\n"; }

# Get the settings

open (DATA, "$datafile");
flock(DATA,2);
@data = <DATA>;
close(DATA);
chomp($data[0]);
($pagetitle,$bgcolor,$text,$link,$alink,$vlink,$background,$yourlink,$password,$notify1,$notify2,$notify3,$notify4,$youremail,$howmany) = split(/\|/, shift(@data));
srand();

# Decide what to do

if ($FORM{'action'} eq "trade") { &trade; }
elsif ($FORM{'action'} eq "submit") { &submit; }
elsif ($FORM{'action'} eq "admin") { &admin; }
elsif ($FORM{'action'} eq "setup") { &setup; }
elsif ($FORM{'action'} eq "approve") { &approve; }
elsif ($FORM{'action'} eq "delete") { &delete; }
elsif ($FORM{'action'} eq "check") { &check; }
elsif ($FORM{'action'} eq "go") { &go; }
elsif ($FORM{'action'} eq "random") { &random; }
else { &links; }


sub links {
        print "<html><head><title>$pagetitle</title></head>\n";
        &body;
        &sig;
        print "<center><table width=\"500\" border=\"5\">\n";
        print "<tr><td><h1><center>$pagetitle</h1>\n";
        if ($#data >= 0) { for ($i = 0; $i <= $#data; $i++) { $data[$i] = "$i|" . $data[$i];} }
        while(@data) {
                $i = int(rand(@data));
                push(@temp, splice(@data, $i, 1));
        }       
        if ($howmany < 1) {
                $howmany = $#temp;
                print "<i>All links are displayed</i>\n";
        }
        else {
                print "<i>$howmany of the $#temp links are displayed on this page</i>\n";
                $howmany--;
        }
        print "<table width=\"150\" bgcolor=\"#88FF88\"><tr><td><center>[<a href=\"$scripturl?action=random\">Random Link</a>]</center></td></tr></table>\n";
        if ($howmany > $#temp) { $howmany = $#temp; }
        print "<table cols=\"2\">\n";
        print "<tr><td width=\"200\"><center>Title</center></td>\n";
        print "<td width=\"300\"><center>Description</center></td></tr>\n";
        for ($i = 0; $i <= $howmany; $i++) {
                ($num,$title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$temp[$i]);
                if ($approved) { print "<tr><td width=\"200\"><a href=\"$scripturl?action=go&link=$num\" target=\"$title\">$title</a></td><td width=\"300\">$desc</td></tr>\n"; }
        }
        print "</table><center>Webmasters: Click <a href=\"$scripturl?action=trade\">here</a> to add your link!</center></tr></td></table>\n";
        &sig;
        print "<form method=\"POST\"><center>Administration<br>Password: <input type=\"password\" name=\"password\">\n";
        print "<br><input type=\"submit\" value=\" Enter \"></center><input type=\"hidden\" name=\"action\" value=\"admin\"></form>\n";
        print "</body></html>\n";
        exit;
}

sub body {
        print "<body bgcolor=\"$bgcolor\" text=\"$text\" link=\"$link\" ";
        print "alink=\"$alink\" vlink=\"$vlink\"";
        if ($background) { print " background=\"$background\""; }
        print ">\n";
}

sub sig  {
# Please DON'T change this sub, or any place where it is called
        print "<center><hr width=\"400\">Link Trader Script by <a href=";
        print "\"http://www.shavenferret.com/cliff\" target=\"new\">Cliff, <a";
        print " href=\"http://www.shavenferret.com\" target=\"new\">Shav";
        print "en Ferret Productions</a>, and available @ <a href=\"http";
        print "://www.shavenferret.com/scripts/\" target=\"new\">http://";
        print "www.shavenferret.com/scripts/</a><hr width=\"400\"></cent";
        print "er>\n";
}

sub trade {
        print "<html><head><title>Add your link!</title></head>\n";
        &body;
        &sig;
        print "<center><h1>Add your link...</h1></center><h2>Just follow these easy steps...</h2><ol>\n";
        print "<li>Copy and paste the following HTML into your web page:<br><center>\n";
        print "<form><textarea cols=\"50\" rows=\"5\" wrap=\"soft\">$yourlink</textarea></form></center><br>\n";
        print "In case you're wondering, that HTML will produce this:<center><br>\n";
        print "$yourlink</center><li>Fill out this form.  All fields are required.<form method=\"POST\">\n";
        print "<center><table width=\"500\" border=\"5\"><tr><td><table cols=\"2\">\n";
        print "<tr><td align=\"right\">Your e-mail address:</td><td><input type=\"text\" name=\"email\">\n";
        print "</td></tr><tr><td align=\"right\">Your URL:</td><td><input type=\"text\" name=\"url\" value=\"http://\">\n";
        print "</td></tr><tr><td align=\"right\">Where can I find my return link?</td><td>\n";
        print "<input type=\"text\" name=\"exchange\" value=\"http://\"></td></tr><tr>\n";
        print "<td align=\"right\">What's your page called:</td><td>\n";
        print "<input type=\"text\" name=\"title\" maxlength=\"75\"></td></tr><tr>\n";
        print "<td align=\"right\">Describe your page:</td><td>\n";
        print "<input type=\"text\" name=\"desc\" maxlength=\"250\"></td></tr>\n";
        print "</table></td></tr></table></center>\n";
        print "<input type=\"hidden\" name=\"action\" value=\"submit\">\n";
        print "<li>Please check everything over, and click <input type=\"submit\" value=\" This Button \">\n";
        &sig;
        print "</form></body></html>\n";
        exit;
}

sub submit {

        # Make sure everything's there.

        unless ($FORM{'title'} && $FORM{'desc'} && $FORM{'url'} && $FORM{'exchange'} && $FORM{'email'}) {
                print "<html><head><title>Missing Information</title></head>\n";
                &body;
                print "<h1>Missing Information</h1>I'm sorry, but it would appear\n";
                print "that you've forgotten to fill something out.  Please click\n";
                print "back and try again.\n";
                exit;
        }

        # Make sure the email and urls are valid

        $temp = $FORM{'email'};
        $temp =~ s/-/a/g;
        $temp =~ s/_/a/g;
        unless ($temp =~ /\w+@\w+\.\w\w+/) {
                print "<html><head><title>Bad e-mail</title></head>\n";
                &body;
                print "<h1>Bad e-mail</h1>The e-mail address that you've entered,\n";
                print "$FORM{'email'}, is invalid.  Please click back and try again\n";
                exit;
        }
        $badurl = 0;
        for ($i = 0; $i < 2; $i++) {
                if ($i == 0) { $test = $FORM{'url'}; }
                else { $test = $FORM{'exchange'}; }
                $test =~ s/-/a/g;
                $test =~ s/_/a/g;
                unless ($test =~ /^(f|ht)tp:\/\/\w+\.\w\w+/) {
                        print "<html><head><title>Bad URL</title></head>\n";
                        &body;
                        print "<h1>Bad URL</h1>\n";
                        print "The URL you entered, $test, is invalid.  Please click\n";
                        print "back and try again.\n";
                        exit;                        
                }
        }

        # add the link to the data file

        open (DATA, ">>$datafile");
        flock(DATA,2);
        print DATA "$FORM{'title'}|$FORM{'desc'}|$FORM{'email'}|$FORM{'exchange'}|$FORM{'url'}|0|0\n";
        close(DATA);

        # e-mail you

        if ($notify1 && $youremail) {
                open (MAIL,"|$mailprogram -t");
                print MAIL "To: $youremail\n";
                print MAIL "From: $FORM{'email'}\n";
                print MAIL "Subject: Please approve link exchange\n";
                print MAIL "$FORM{'email'} has stopped by your page\n";
                print MAIL "and requested a link exchange.  Please come to\n";
                print MAIL "$scripturl and approve their link.\n";
                close(MAIL);
        }

        if ($notify2) {
                open (MAIL,"|$mailprogram -t");
                print MAIL "To: $FORM{'email'}\n";
                print MAIL "From: $youremail\n";
                print MAIL "Subject: Thank you!\n";
                print MAIL "Thanks for submitting your link!  If you haven't\n";
                print MAIL "done so already, please copy and paste the following\n";
                print MAIL "HTML into your page at $FORM{'exchange'}:\n\n";
                print MAIL "$yourlink\n\n";
                &emailsig;
                close(MAIL);
        }
        # prints out a response

        print "<html><head><title>Thank you!</title></head>\n";
        &body;
        print "<h1>Thank you!</h1>Thanks for submitting your link!\n";
        print "I will check it out as soon as possible.</body></html>\n";
        exit;
}

sub admin {
        &checkpassword;
        print "<html><head><title>Administration</title></head>\n";
        &body;
        print "<center><a href=\"http://www.cgi-resources.com/rate?02076\">Rate this Script @ The CGI Resource Index</a></center>\n";
        print "<center><form method=\"POST\" action=\"http://www.shavenferret.com/cgi-bin/list/subscribe.cgi\">\n";
        print "<input type=\"hidden\" name=\"action\" value=\"subscribe\">\n";
        print "<input type=\"hidden\" name=\"9\" value=\"-1\">\n";
        print "<table width=\"300\" bgcolor=\"#FF0000\" border=\"3\">\n";
        print "<tr><td><center><font color=\"#000000\"><b>Want to be notified whenever I release a new version of this script?\n";
        print "</b><br><b>Your e-mail:</b><input type=\"text\" name=\"email\" value=\"$youremail\"><br><input type=\"submit\" value=\" Subscribe me! \">\n";
        print "</font></center></td></tr></table></form></center>\n";
        print "<h1>Approve a link</h1>\n";
        $notapproved = 0;
        $num = 0;
        foreach $line(@data) {
                chomp($line);
                ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$line);
                unless ($approved) {
                        print "<form method=\"POST\">\n";
                        print "<input type=\"hidden\" name=\"stage\" value=\"0\">\n";
                        print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
                        print "<input type=\"hidden\" name=\"num\" value=\"$num\">\n";
                        &linkhtml($line);
                        if ($lwp) {
                                $temp = get($exchange);
                                $temp =~ s/\n/ /g;
                                $temp =~ s/\s+/ /g;
                                print "<tr><td align=\"right\" valign=\"top\">Your return link:</td><td>\n";
                                if ($temp =~ /$yourlink/) {
                                        print "<b>is</b> up, but you <a href=\"#yes\">might not want to trust this</a>.</td></tr>\n"; 
                                }
                                else {
                                        print "is <b>not</b> up, but you <a href=\"#no\">might not want to trust this</a>.</td></tr>\n";
                                }
                        }
                        print "<tr><td align=\"right\">Should I convert the title and description to lower case?</td><td>\n";
                        print "<select name=\"lcase\"><option selected>No<option value=\"-1\">Yes</select></td></tr>\n";
                        print "<tr><td align=\"right\">What should I do?</td>\n";
                        print "<td><select name=\"action\"><option value=\"approve\">Approve this link<option value=\"delete\">Delete this link</select></td></tr>\n";
                        print "<tr><td align=\"right\">If you chose to delete this link, what should I tell the webmaster?</td><td>\n";
                        print "<select name=\"which\"><option value=\"-1\">Nothing<option value=\"1\">Couldn't find return link\n";
                        print "<option value=\"2\">Could find link to links page<option value=\"3\">Can't trade with site\n";
                        print "<option value=\"4\">Bad link syntax<option value=\"5\">Page is 404<option value=\"0\">Something else</select></td></tr>\n";
                        print "<tr><td align=\"right\">If you picked &quot;Something else&quot;, what should I tell the webmaster?</td>\n";
                        print "<td><input type=\"text\" name=\"other\"></td></tr>\n";
                        print "<tr><td align=\"right\"><input type=\"submit\" value=\"Do it!\"></td>\n";
                        print "<td><input type=\"reset\"></td></tr></table></td></tr></table>\n";
                        print "</form><p>\n";
                        $notapproved++;                        
                }
                $num++;
        }
        print "<center><hr width=\"400\"></center><h1>Statistics</h1><ul>\n";
        $lowest[0] = 9999999;
        for ($i = 0; $i <= $#data; $i++) {
                ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$data[$i]);
                $total += $hits;
                if ($hits > $highest[0]) { $highest[0] = $hits; $highest[1] = $url; $highest[2] = $title; }
                if ($hits < $lowest[0]) { $lowest[0] = $hits; $lowest[1] = $url; $lowest[2] = $title; }
        }
        if (($#data + 1) != 0) { $average = ($total / ($#data + 1)); }
        else { $average = "N\A"; }
        print "<li>Number of links: $#data\n";
        print "<li>Total outgoing hits: $total\n";
        print "<li>Average hits per page: $average\n";
        print "<li>Highest number of hits: <a href=\"$highest[1]\">$highest[2]</a> ($highest[0] hits)\n";
        print "<li>Lowest number of hits: <a href=\"$lowest[1]\">$lowest[2]</a> ($lowest[0] hits)\n";
        print "<center><hr width=\"400\"></center><h1>Setup</h1>\n";
        print "<form method=\"POST\">\n";
        print "<input type=\"hidden\" name=\"action\" value=\"setup\">\n";
        print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
        print "<center><table border=\"5\" width=\"500\"><tr><td><table cols=\"2\">\n";
        print "<tr><td align=\"right\">Title of links page:</td>\n";
        print "<td><input type=\"text\" name=\"pagetitle\" value=\"$pagetitle\"></td></tr>\n";
        print "<tr><td align=\"right\">Background color:</td>\n";
        print "<td><input type=\"text\" name=\"bgcolor\" value=\"$bgcolor\" size=\"7\"></td></tr>\n";
        print "<tr><td align=\"right\">Text color:</td>\n";
        print "<td><input type=\"text\" name=\"text\" value=\"$text\" size=\"7\"></td></tr>\n";
        print "<tr><td align=\"right\">Link color:</td>\n";
        print "<td><input type=\"text\" name=\"link\" value=\"$link\" size=\"7\"></td></tr>\n";
        print "<tr><td align=\"right\">Active link color:</td>\n";
        print "<td><input type=\"text\" name=\"alink\" value=\"$alink\" size=\"7\"></td></tr>\n";
        print "<tr><td align=\"right\">Visited link color:</td>\n";
        print "<td><input type=\"text\" name=\"vlink\" value=\"$vlink\" size=\"7\"></td></tr>\n";
        print "<tr><td align=\"right\">URL of background image</td>\n";
        print "<td><input type=\"text\" name=\"background\" value=\"$background\"></td></tr>\n";
        print "<tr><td align=\"right\">What should your return link say?</td>\n";
        print "<td><textarea name=\"yourlink\" cols=\"20\" rows=\"2\" wrap=\"soft\">$yourlink</textarea></td></tr>\n";        
        print "<tr><td align=\"right\">What password do you want to use?</td>\n";
        print "<td><input type=\"text\" name=\"pw\" value=\"$FORM{'password'}\"></td></tr>\n";
        print "<tr><td align=\"right\">Do you want to be notified by email when a link is submitted?</td>\n";
        print "<td><select name=\"notify1\"><option value=\"0\"";
        if ($notify1) { print ">No<option value=\"1\" selected>Yes</select></td></tr>\n"; }
        else { print " selected>No<option value=\"1\">Yes</select></td></tr>\n"; }
        print "<tr><td align=\"right\">Do you want to be notified by email when someone tries to guess your password?</td>\n";
        print "<td><select name=\"notify2\"><option value=\"0\"";
        if ($notify2) { print ">No<option value=\"1\" selected>Yes</select></td></tr>\n"; }
        else { print " selected>No<option value=\"1\">Yes</select></td></tr>\n"; }
        print "<tr><td align=\"right\">Do you want this script to automatically e-mail a reminder to add your link whenever someone submits a link?</td>\n";
        print "<td><select name=\"notify3\"><option value=\"0\"";
        if ($notify3) { print ">No<option value=\"1\" selected>Yes</select></td></tr>\n"; }
        else { print " selected>No<option value=\"1\">Yes</select></td></tr>\n"; }
        print "<tr><td align=\"right\">Do you want this script to automatically e-mail webmasters when their link is approved?</td>\n";
        print "<td><select name=\"notify4\"><option value=\"0\"";
        if ($notify4) { print ">No<option value=\"1\" selected>Yes</select></td></tr>\n"; }
        else { print " selected>No<option value=\"1\">Yes</select></td></tr>\n"; }
        print "<tr><td align=\"right\">Your e-mail address:</td>\n";
        print "<td><input type=\"text\" name=\"youremail\" value=\"$youremail\"></td></tr>\n";
        print "<tr><td align=\"right\">How many links should I display on the page?  Enter -1 to show them all.</td>\n";
        print "<td><input type=\"text\" name=\"howmany\" value=\"$howmany\" size=\"4\"></td></tr>\n";
        print "<tr><td align=\"right\"><input type=\"submit\" value=\" Update Setup \"></td>\n";
        print "<td><input type=\"reset\"></td></tr>\n";
        print "</table></td></tr></table></form>\n";
        print "<center><hr width=\"400\"></center>\n";
        print "<h1>Screw with approved links</h1>\n";
        $num = 0;
        foreach $line(@data) {
                chomp($line);
                ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$line);
                if ($approved == 1) {
                        print "<form method=\"POST\">\n";
                        print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
                        print "<input type=\"hidden\" name=\"num\" value=\"$num\">\n";
                        print "<input type=\"hidden\" name=\"stage\" value=\"1\">\n";
                        &linkhtml($line);
                        print "<tr><td align=\"right\">What should I do?</td>\n";
                        print "<td><select name=\"action\"><option value=\"approve\">Modify Link<option value=\"delete\">Remove Link</select></td></tr>\n";
                        print "<tr><td align=\"right\">If you chose to delete this link, what should I tell the webmaster?</td><td>\n";
                        print "<select name=\"which\"><option value=\"-1\">Nothing<option value=\"1\">Couldn't find return link\n";
                        print "<option value=\"2\">Could find link to links page<option value=\"3\">Can't trade with site\n";
                        print "<option value=\"4\">Bad link syntax<option value=\"5\">Page is 404<option value=\"0\">Something else</select></td></tr>\n";
                        print "<tr><td align=\"right\">If you picked &quot;Something else&quot;, what should I tell the webmaster?</td>\n";
                        print "<td><input type=\"text\" name=\"other\"></td></tr>\n";
                        print "<tr><td align=\"right\"><input type=\"submit\" value=\" Do it! \"></td>\n";
                        print "<td><input type=\"reset\"></td></tr>\n";
                        print "</table></td></tr></table></form><p>\n";
                        $appr++;
                }
                $num++;
        }
        unless ($appr > 0) { print "No approved links to screw with!\n"; }
        else {
                print "<center><hr width=\"400\"></center><h1>Check for return links</h1>\n";
                if ($lwp) {
                        print "This form can be used to make sure all the return link pages\n";
                        print "contain certain text, by default, your link, and let you know\n";
                        print "which pages have it and which don't.\n";
                        print "<form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"check\">\n";
                        print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
                        print "<center><table cols=\"2\" width=\"400\">\n";
                        print "<tr><td align=\"right\">What text should I search the pages for?\n";
                        print "<td><textarea name=\"search\" cols=\"20\" rows=\"5\" wrap=\"soft\">$yourlink</textarea></td></tr>\n";
                        print "</table>Warning:  This may take some time.  Expect to wait about 2.5 seconds per link\n";
                        $i = $appr * 2;
                        print "($i seconds total)<br><input type=\"submit\" value=\" Search \"></form>\n";
                }
                else {
                        print "</center>Because you are not using libwww-perl, I cannot check the\n";
                        print "links for you.  However, I can give you this wonderful list\n";
                        print "of where your return link is supposed to be.  Each link will\n";
                        print "open in a new window...<ul>If you are\n";
			print "a system administrator, and you'd like to get libwww-perl,\n";
			print "you can find it at <a href=\"http://www.ics.uci.edu/pub/we";
			print "bsoft/libwww-perl/\">http://www.ics.uci.edu/pub/websoft/li";
			print "bwww-perl/</a>\n";                 
                        foreach $line(@data) {
                                chomp($line);
                                ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$line);
                                if ($approved == 1) {
                                        print "<li><a href=\"$exchange\" target=\"$exchange\">$title</a>\n";
                                }        
                        }
                        print "</ul>\n";
                }
        }
        if ($lwp == 1 && $notapproved > 0) { &believe; }
        print "</body></html>\n";
        exit;
}

sub checkpassword {
        if ($FORM{'password'} eq "") {
                print "<html><head><title>You need a password for that!</title></head>\n";
                print "I'm sorry, but you need the password to do that.</body></html>\n";
                exit;
        }
        elsif ($FORM{'password'} ne $password) {
                if (($ENV{'REMOTE_HOST'} eq $ENV{'REMOTE_ADDR'}) && ($ENV{'REMOTE_ADDR'} =~ /(\d+)\.(\d+)\.(\d+)\.(\d+)/)) {
                        $Address = pack('C4', $1, $2, $3, $4);
                        $DNS_Address = (gethostbyaddr($Address, 2))[0];
                        $ENV{'REMOTE_HOST'} = $DNS_Address if $DNS_Address;
                }
                print "<html><head><title>Bad password</title></head>\n";
                &body();
                print "<h1>Bad Password</h1><br>\n";
                print "The password you entered, $FORM{'password'}, is incorrect.\n";
                if ($notify2 && $youremail) {
                        print "The following information has been mailed to the owner of\n";
                        print "this page.<ul>\n";
                        print "<li>Domain: $ENV{'REMOTE_HOST'}\n";
                        print "<li>IP Address: $ENV{'REMOTE_ADDR'}";
                        print "<li>Password: $FORM{'password'}\n";
                        print "</ul></body></html>\n";
                        open (MAIL,"|$mailprogram -t");
                        print MAIL "To: $youremail\n";
                        print MAIL "From: hell.if\@i.know\n";
                        print MAIL "Subject: Attempted hack\n\n";
                        print MAIL "Someone has tried to guess your password for your\n";
                        print MAIL "link trading page!  The following information was grabbed:\n";
                        print MAIL "* Domain: $ENV{'REMOTE_HOST'}\n";
                        print MAIL "* IP Address: $ENV{'REMOTE_ADDR'}\n";
                        print MAIL "* Password: $FORM{'password'}\n";
                        close (MAIL);
                }
                exit;
        }
}

sub setup {
        &checkpassword;
        open (FILE,">$datafile");
        flock(FILE,2);
        print FILE "$FORM{'pagetitle'}|$FORM{'bgcolor'}|$FORM{'text'}|$FORM{'link'}|$FORM{'alink'}|$FORM{'vlink'}|$FORM{'background'}|$FORM{'yourlink'}|$FORM{'pw'}|$FORM{'notify1'}|$FORM{'notify2'}|$FORM{'notify3'}|$FORM{'notify4'}|$FORM{'youremail'}|$FORM{'howmany'}\n";
        foreach $line(@data) { print FILE "$line"; }
        close(FILE);
        print "<html><head><title>Setup Changed.</title></head>\n";
        &body;
        print "The setup file has been changed. \n";
        &back("pw");
        exit;
}

sub approve {
        &checkpassword;
        if ($FORM{'lcase'} == -1) {
                $FORM{'title'} =~ tr/A-Z/a-z/;
                $FORM{'desc'} =~ tr/A-Z/a-z/;
        }
        open (FILE,">$datafile");
        flock(FILE,2);
        print FILE "$pagetitle|$bgcolor|$text|$link|$alink|$vlink|$background|$yourlink|$password|$notify1|$notify2|$notify3|$notify4|$youremail|$howmany\n";
        splice (@data, $FORM{'num'}, 1, ("$FORM{'title'}|$FORM{'desc'}|$FORM{'email'}|$FORM{'exchange'}|$FORM{'url'}|1|$FORM{'hits'}\n"));
        foreach $line(@data) { print FILE "$line"; }
        close(FILE);
        if ($FORM{'stage'} == 0) {
                $x = "approved";
                if ($notify4) {
                        open (MAIL,"|$mailprogram -t");
                        print MAIL "To: $FORM{'email'}\n";
                        print MAIL "From: $youremail\n";
                        print MAIL "Subject: Your link has been approved!\n";
                        print MAIL "Congratulations!  Your link has been approved,\n";
                        print MAIL "and can be found at $scripturl\n\n";
                        &emailsig;
                        close(MAIL);
                }
        }
        if ($FORM{'stage'} == 1) { $x = "modified"; }
        print "<html><head><title>Link $x</title></head>\n";
        &body;
        print "<h1>Link $x</h1>The link has been $x.\n";
        &back("password");
}


sub defemail {

        # this sub defines the e-mail messages.  If you'd like to edit it,
        # remember to put a \ before any $ @ \ " characters.

        $response[0] = $FORM{'other'};

        $response[1] = " because\n";
        $response[1] .= "I could not find my return link.  If you'd like to\n";
        $response[1] .= "try again, please go to $scripturl\n\n";
        $response[1] .= "Thanks for your time!\n";

        $response[2] = " because\n";
        $response[2] .= "I couldn't find any links to the page where my\n";
        $response[2] .= "link was from your main page.  If you'd like to\n";
        $response[2] .= "try again, please go to $scripturl\n\n";
        $response[2] .= "Thanks for your time!\n";

        $response[3] = " because\n";
        $response[3] .= "I cannot trade links with sites of that nature.\n\n";
        $response[3] .= "Sorry about that.\n";

        $response[4] = " because\n";
        $response[4] .= "you did not use the correct link syntax.  If you'd\n\n";
        $response[4] .= "like to try again, please go to $scripturl\n\n";
        $response[4] .= "Thanks for your time!\n";
        
        $response[5] .= " because\n";
        $response[5] .= "I was either unable to access your main page, or the\n";
        $response[5] .= "page where my return link was.  If you'd like to try\n";
        $response[5] .= "again, please go to $scripturl\n\n";
        $response[5] .= "Thanks for your time!\n";
        return(@response);
}

sub delete {
        &checkpassword;
        print "<html><head><title>Link Deleted</title></head>\n";
        &body;
        print "<h1>Link Deleted</h1>The link has been removed ";
        if ($FORM{'which'} != -1) {
                ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$data[$FORM{'num'}]);
                open (MAIL,"|$mailprogram -t");
                print MAIL "To: $email\n";
                print MAIL "From: $youremail\n";
                print MAIL "Subject: Sorry\n";
                if ($FORM{'which'} == 0) {
                        print MAIL "$FORM{'other'}\n";
                }
                else {
                        if ($FORM{'stage'} == 0) { print MAIL "I'm sorry, but your link was not approved"; }
                        else { print MAIL "I'm sorry, but your link was removed"; }
                        @response = &defemail;
                        print MAIL "$response[$FORM{'which'}]\n";
                }
                &emailsig;
                close(MAIL);
                print ", and the webmaster has been e-mailed";
        }
        splice (@data, $FORM{'num'}, 1);
        open (FILE,">$datafile");
        flock(FILE,2);
        print FILE "$pagetitle|$bgcolor|$text|$link|$alink|$vlink|$background|$yourlink|$password|$notify1|$notify2|$notify3|$notify4|$youremail|$howmany\n";
        foreach $line(@data) { print FILE "$line"; }
        close(FILE);
        &back("password");
}

sub emailsig {
        # Please DON'T change this sub or any place where it is called
        print MAIL "*********************************************************\n";
        print MAIL "*  I'm using Cliff's Link Trader Script, a FREE perl    *\n";
        print MAIL "*  script that makes trading links insanely easy.  If   *\n";
        print MAIL "* you can run cgi scripts on your server and you'd like *\n";
        print MAIL "*             to try this script out, go to             *\n";
        print MAIL "*      http://www.shavenferret.com/scripts/linkt/       *\n";
        print MAIL "*********************************************************\n";
}

sub believe {
        print "<hr width=\"400\"></center>\n";
        print "<a name=\"yes\"><b>Why you shouldn't trust it when it says your link is there</b></a><br>\n";
        print "My script will make sure that the text for your link appears somewhere\n";
        print "in the specified page.  However, there are a few things that it won't notice...\n";
        print "<ul><li>It won't notice if your link is between comment tags\n";
        print "<li>It won't notice if your link is the same color as the background\n";
        print "<li>It won't notice if your link is on a page that has no links to it\n";
        print "<li>It won't notice if your link is so deeply burried in other links that it might as well not exist.\n";
        print "</ul>\n";
        print "<center><hr width=\"400\"></center>\n";
        print "<a name=\"no\"><b>Why you shouldn't trust it when it says your link isn't there</b><br></a>\n";
        print "Unless the <b>exact</b> text you've specified is on the page, my script will tell you the link is not there.\n";
}

sub linkhtml {
        $line = shift(@_);
        ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$line);
        print "<center><table width=\"500\" border=\"5\"><tr><td>\n";
        print "<table cols=\"2\"><tr><td align=\"right\">Title:</td>\n";
        print "<td><input type=\"text\" name=\"title\" value=\"$title\"></td></tr>\n";
        print "<tr><td align=\"right\">Description:</td>\n";
        print "<td><input type=\"text\" name=\"desc\" value=\"$desc\"></td></tr>\n";
        print "<tr><td align=\"right\">E-mail:</td>\n";
        print "<td><input type=\"text\" name=\"email\" value=\"$email\"></td></tr>\n";
        print "<tr><td align=\"right\"><a href=\"$url\">Main URL</a>:</td>\n";
        print "<td><input type=\"text\" name=\"url\" value=\"$url\"></td></tr>\n";
        print "<tr><td align=\"right\"><a href=\"$exchange\">URL where you can find your link</a>:</td>\n";
        print "<td><input type=\"text\" name=\"exchange\" value=\"$exchange\"></td></tr>\n";
        print "<tr><td align=\"right\">Hits:</td>\n";
        print "<td><input type=\"text\" name=\"hits\" value=\"$hits\" size=\"4\"></td></tr>\n";
}

sub back {
        $pass = shift(@_);
        print "<form method=\"POST\">\n";
        print "<input type=\"hidden\" name=\"password\" value=\"$FORM{$pass}\">\n";
        print "<input type=\"hidden\" name=\"action\" value=\"admin\">\n";
        print "Click <input type=\"submit\" value=\" here \"></form> to go back.\n";
        print "</body></html>\n";
        exit;
}

sub check {
        &checkpassword;
        print "<html><head><title>Deleted</title></head>\n";
        &body;
        print "<h1>Deleted</h1>The following links were deleted:<ul>\n";
        $num = 0;
        for ($i = $#data; $i >= 0; $i--) {
                ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$data[$i]);
                if ($approved) {
                        $page = get($exchange);
                        $page =~ tr/A-Z/a-z/;
                        $page =~ s/\n/ /g;
                        $page =~ s/\s+/ /g;
                        $FORM{'search'} =~ tr/A-Z/a-z/;
                        unless ($page =~ /$FORM{'search'}/) {
                                print "<li><a href=\"$url\">$title</a> (no return at <a href=\"$exchange\">$exchange</a>)\n";;
                                open (MAIL,"|$mailprogram -t");
                                print MAIL "To: $email\n";
                                print MAIL "From: $youremail\n";
                                print MAIL "Subject: Sorry\n";
                                print MAIL "I'm sorry, but your link was removed from my\n";
                                print MAIL "links page at $scripturl\n";
                                print MAIL "because I could not find my link on your page\n";
                                print MAIL "at $exchange\n\n";
                                &emailsig;
                                close(MAIL);
                                splice(@data,$i,1);
                                open (FILE,">$datafile");
                                flock(FILE,2);
                                print FILE "$pagetitle|$bgcolor|$text|$link|$alink|$vlink|$background|$yourlink|$password|$notify1|$notify2|$notify3|$notify4|$youremail\n";
                                foreach $line(@data) { print FILE "$line"; }
                                close(FILE);
                        }
                }
        }
        print "</ul>\n";
        &back("password");
}

sub go {
        chomp($data[$FORM{'link'}]);
        ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$data[$FORM{'link'}]);
        $hits++;
        $data[$FORM{'link'}] = "$title|$desc|$email|$exchange|$url|$approved|$hits\n";
        open (FILE,">$datafile");
        flock(FILE,2);
        print FILE "$pagetitle|$bgcolor|$text|$link|$alink|$vlink|$background|$yourlink|$password|$notify1|$notify2|$notify3|$notify4|$youremail|$howmany\n";
        foreach $line(@data) { print FILE "$line"; }
        close(FILE);
        print "Location: $url\n\n";
        exit;
}

sub random {
        while(-1) {
                $FORM{'link'} = int(rand(@data));
                ($title,$desc,$email,$exchange,$url,$approved,$hits) = split(/\|/,$data[$FORM{'link'}]);
                if ($approved) { &go; }
        }
}

